diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/government.c freeciv-patched/common/government.c
--- freeciv-cvs/common/government.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/common/government.c	2003-06-30 12:18:03.000000000 +0100
@@ -63,7 +63,7 @@
 struct ai_gov_tech_hint ai_gov_tech_hints[MAX_NUM_TECH_LIST];
 
 static const char *flag_names[] = {
-  "Build_Veteran_Diplomats", "Revolution_When_Unhappy", "Has_Senate",
+  "(unused)", "Revolution_When_Unhappy", "Has_Senate",
   "Unbribable", "Inspires_Partisans", "Rapture_City_Growth",
   "Fanatic_Troops", "No_Unhappy_Citizens", "Convert_Tithes_To_Money",
   "Reduced_Research"
@@ -251,10 +251,15 @@
      * ever get it, then we can't change to the gov type even if we have
      * a wonder that would otherwise allow it. */
     return FALSE;
+  } else if (get_invention(pplayer, req) == TECH_KNOWN) {
+    return TRUE;
   } else {
-    return (get_invention(pplayer, req) == TECH_KNOWN
-	    || player_owns_active_govchange_wonder(pplayer));
+    /* Do we have the Any_Government effect? */
+    impr_effects_iterate(iter, B_LAST, NULL, pplayer) {
+      if (iter.imeff->type == EFT_ANY_GOVERNMENT) return TRUE;
+    } impr_effects_iterate_end;
   }
+  return FALSE;
 }
 
 /***************************************************************
@@ -290,6 +295,9 @@
 ***************************************************************/
 static void government_free(struct government *gov)
 {
+  free(gov->effect);
+  gov->effect = NULL;
+
   free(gov->ruler_titles);
   gov->ruler_titles = NULL;
 
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/government.h freeciv-patched/common/government.h
--- freeciv-cvs/common/government.h	2003-06-30 12:18:25.000000000 +0100
+++ freeciv-patched/common/government.h	2003-06-30 12:17:55.000000000 +0100
@@ -18,6 +18,7 @@
 struct city;
 struct player;
 struct Sprite;			/* opaque; client-gui specific */
+struct impr_effect;
 
 #define G_MAGIC (127)		/* magic constant, used as flag value */
 
@@ -25,7 +26,8 @@
 #define G_CITY_SIZE_FREE          G_MAGIC
 
 enum government_flag_id {
-  G_BUILD_VETERAN_DIPLOMAT=0,	/* and Spies (in general: all F_DIPLOMAT) */
+  G_BUILD_VETERAN_DIPLOMAT=0,	/* obsolete - use Unit_Veteran effect in
+				 * units.ruleset instead */
   G_REVOLUTION_WHEN_UNHAPPY,
   G_HAS_SENATE,			/* not implemented */
   G_UNBRIBABLE,
@@ -152,6 +154,8 @@
   int   hints;
 
   struct Sprite *sprite;
+
+  struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
   
   char *helptext;
 };
